﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace pr224_1
{
    // Класс с главным методом:
    class Program
    {
        // Статический метод:
        static void generator(string num)
        {
            // Отображение сообщения:
            Console.WriteLine("Метод с аргументом \"{0}\" начинает paботу", num);
            // Текстовая переменная: 
            string msg = "Массив не создан!";
            // Контролируемый код: 
            try
            {
                // Преобразование текста в целое число: 
                int m = Int32.Parse(num);
                // Создание массива: 
                int[] array = new int[m];
                // Новое значение текстовой переменной: 
                msg = "Создан массив: ";
                // Цикл: 
                for (int k = 0; k <= 4; k++)
                {
                    // Элементу массива присваивается значение: 
                    array[k] = 12 / (4 - k);
                    // К тексту добавляется значение элемента: 
                    msg += " " + array[k];
                }
            }
            // Обработка ошибки выхода за пределы массива: 
            catch (IndexOutOfRangeException)
            {
                // Отображение сообщения:
                Console.WriteLine("Ошибка в методе: выход за пределы массива");
            }
            // Код для обязательного выполнения: 
            finally
            {
                // Отображение значения текстовой переменной:
                Console.WriteLine(msg);
            }
            // Отображение сообщения:
            Console.WriteLine("Meтод завершил работу");
        }

        static void Main()
        {
            // Главный метод: 
            // Текстовый массив:
            string[] args = { "один", "-2", "5", "2" };
            // Символьный массив из одного элемента: 
            char[] symbs = new char[1];
            // Цикл:
            for (int k = 0; k < args.Length; k++)
            {
                // Контролируемый код (внешний блок): 
                try
                {
                    // Отображение сообщения:
                    Console.WriteLine("Выполняется цикл №{0}: ", k + 1);
                    // Контролируемый код (внутренний блок):
                    try
                    {
                        // Вызов статического метода: 
                        generator(args[k]);
                        // Команда с ошибкой (неверный индекс): 
                        symbs[1] = 'A';
                    }
                    // Обработка ошибки деления на ноль 
                    // (внутренний блок): 
                    catch (DivideByZeroException e)
                    {
                        // Отображение сообщения:
                        Console.WriteLine("Первый внутренний catch-блок: {0}", e.GetType().Name);
                    }
                    // Обработка ошибки выхода за пределы массива 
                    // (внутренний блок): 
                    catch (IndexOutOfRangeException e)
                    {
                        // Отображение сообщения:
                        Console.WriteLine("Второй внутренний catch-блок: {0}", e.GetType().Name);
                    }
                    // Обязательный для выполнения код: 
                    finally
                    {
                        // Элементу массива присваивается значение: 
                        symbs[0] = (char)('A' + k);
                        // Отображение сообщения:
                        Console.WriteLine("Символ: \'{0}\'", symbs[0]);
                    }
                }
                // Обработка всех ошибок (внешний блок): 
                catch (Exception e)
                {
                    // Отображение сообщения:
                    Console.WriteLine("Внешний catch-блок: {0}", e.GetType().Name);
                }
                // Отображение сообщения:
                Console.WriteLine("Цикл №{0} завершен...\n", k + 1);




            }
            // Задержка:
            Console.ReadLine();
        }
    }
}
